curl --request POST \
--url https://api.cloudpay.africa/cloudpay/v1/merchants/{merchantID}/collections \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"amount": 123,
"idempotency_key": "<string>",
"till_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"msisdn": 712345678,
"email": "<string>",
"reference": "<string>"
}
'import requests
url = "https://api.cloudpay.africa/cloudpay/v1/merchants/{merchantID}/collections"
payload = {
"amount": 123,
"idempotency_key": "<string>",
"till_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"msisdn": 712345678,
"email": "<string>",
"reference": "<string>"
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
amount: 123,
idempotency_key: '<string>',
till_id: '3c90c3cc-0d44-4b50-8888-8dd25736052a',
msisdn: 712345678,
email: '<string>',
reference: '<string>'
})
};
fetch('https://api.cloudpay.africa/cloudpay/v1/merchants/{merchantID}/collections', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.cloudpay.africa/cloudpay/v1/merchants/{merchantID}/collections",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'amount' => 123,
'idempotency_key' => '<string>',
'till_id' => '3c90c3cc-0d44-4b50-8888-8dd25736052a',
'msisdn' => 712345678,
'email' => '<string>',
'reference' => '<string>'
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.cloudpay.africa/cloudpay/v1/merchants/{merchantID}/collections"
payload := strings.NewReader("{\n \"amount\": 123,\n \"idempotency_key\": \"<string>\",\n \"till_id\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"msisdn\": 712345678,\n \"email\": \"<string>\",\n \"reference\": \"<string>\"\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.cloudpay.africa/cloudpay/v1/merchants/{merchantID}/collections")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"amount\": 123,\n \"idempotency_key\": \"<string>\",\n \"till_id\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"msisdn\": 712345678,\n \"email\": \"<string>\",\n \"reference\": \"<string>\"\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.cloudpay.africa/cloudpay/v1/merchants/{merchantID}/collections")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"amount\": 123,\n \"idempotency_key\": \"<string>\",\n \"till_id\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"msisdn\": 712345678,\n \"email\": \"<string>\",\n \"reference\": \"<string>\"\n}"
response = http.request(request)
puts response.read_body{
"status": {
"ok": true,
"code": 123,
"desc": "<string>"
},
"data": {
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"merchant_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"till_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"batch_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"status": "initiated",
"provider": "mpesa",
"method": "stk",
"custody": "platform",
"msisdn": "<string>",
"amount": 123,
"fee": 123,
"fee_borne_by": "merchant",
"net": 123,
"reference": "<string>",
"receipt": "<string>",
"checkout_path": "<string>",
"checkout_url": "<string>",
"failure_reason": "<string>",
"failure_category": "review",
"failure_label": "Cancelled by payer",
"created_at": "2023-11-07T05:31:56Z",
"updated_at": "2023-11-07T05:31:56Z"
}
}{
"status": {
"ok": false,
"code": 422,
"desc": "Unprocessable Entity"
},
"errors": {
"code": "insufficient_funds",
"message": "insufficient funds"
}
}{
"status": {
"ok": false,
"code": 422,
"desc": "Unprocessable Entity"
},
"errors": {
"code": "insufficient_funds",
"message": "insufficient funds"
}
}{
"status": {
"ok": false,
"code": 422,
"desc": "Unprocessable Entity"
},
"errors": {
"code": "insufficient_funds",
"message": "insufficient funds"
}
}Collect from a payer on the merchant's collection rail
method: stk (default: an M-Pesa prompt via M-Pesa, SasaPay or a Paystack charge) or checkout
(Paystack popup; send the payer to checkout_url). Whole shillings on M-Pesa/SasaPay. No money moves
until the rail confirms: poll GET .../collections/{id}. A cashier collects into their own till only.
Needs collect.
Test environment: each prompt is capped at KES 100 (400 test_amount_limit); the prompt is
refused before anything is recorded. A live merchant not yet approved for production is
refused with 403 production_not_approved.
Development also has a daily ceiling per tenant (default KES 1,000; staff set test_daily_limit, 0 disables
Development collections): today’s non-failed collections (Africa/Nairobi day) plus this one over it is
refused with 400 test_daily_limit before anything is recorded.
curl --request POST \
--url https://api.cloudpay.africa/cloudpay/v1/merchants/{merchantID}/collections \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"amount": 123,
"idempotency_key": "<string>",
"till_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"msisdn": 712345678,
"email": "<string>",
"reference": "<string>"
}
'import requests
url = "https://api.cloudpay.africa/cloudpay/v1/merchants/{merchantID}/collections"
payload = {
"amount": 123,
"idempotency_key": "<string>",
"till_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"msisdn": 712345678,
"email": "<string>",
"reference": "<string>"
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
amount: 123,
idempotency_key: '<string>',
till_id: '3c90c3cc-0d44-4b50-8888-8dd25736052a',
msisdn: 712345678,
email: '<string>',
reference: '<string>'
})
};
fetch('https://api.cloudpay.africa/cloudpay/v1/merchants/{merchantID}/collections', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.cloudpay.africa/cloudpay/v1/merchants/{merchantID}/collections",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'amount' => 123,
'idempotency_key' => '<string>',
'till_id' => '3c90c3cc-0d44-4b50-8888-8dd25736052a',
'msisdn' => 712345678,
'email' => '<string>',
'reference' => '<string>'
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.cloudpay.africa/cloudpay/v1/merchants/{merchantID}/collections"
payload := strings.NewReader("{\n \"amount\": 123,\n \"idempotency_key\": \"<string>\",\n \"till_id\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"msisdn\": 712345678,\n \"email\": \"<string>\",\n \"reference\": \"<string>\"\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.cloudpay.africa/cloudpay/v1/merchants/{merchantID}/collections")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"amount\": 123,\n \"idempotency_key\": \"<string>\",\n \"till_id\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"msisdn\": 712345678,\n \"email\": \"<string>\",\n \"reference\": \"<string>\"\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.cloudpay.africa/cloudpay/v1/merchants/{merchantID}/collections")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"amount\": 123,\n \"idempotency_key\": \"<string>\",\n \"till_id\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"msisdn\": 712345678,\n \"email\": \"<string>\",\n \"reference\": \"<string>\"\n}"
response = http.request(request)
puts response.read_body{
"status": {
"ok": true,
"code": 123,
"desc": "<string>"
},
"data": {
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"merchant_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"till_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"batch_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"status": "initiated",
"provider": "mpesa",
"method": "stk",
"custody": "platform",
"msisdn": "<string>",
"amount": 123,
"fee": 123,
"fee_borne_by": "merchant",
"net": 123,
"reference": "<string>",
"receipt": "<string>",
"checkout_path": "<string>",
"checkout_url": "<string>",
"failure_reason": "<string>",
"failure_category": "review",
"failure_label": "Cancelled by payer",
"created_at": "2023-11-07T05:31:56Z",
"updated_at": "2023-11-07T05:31:56Z"
}
}{
"status": {
"ok": false,
"code": 422,
"desc": "Unprocessable Entity"
},
"errors": {
"code": "insufficient_funds",
"message": "insufficient funds"
}
}{
"status": {
"ok": false,
"code": 422,
"desc": "Unprocessable Entity"
},
"errors": {
"code": "insufficient_funds",
"message": "insufficient funds"
}
}{
"status": {
"ok": false,
"code": 422,
"desc": "Unprocessable Entity"
},
"errors": {
"code": "insufficient_funds",
"message": "insufficient funds"
}
}